## cryfs 0.9.6

=== CMakeLists.txt ===
# We only allow generating distribution packages if:
# - it is a release build (to ensure all generated debian packages are fine to be distributed)
# - tests are not built (because otherwise CPack would start installing googletest with the package as well)
string(TOUPPER "${CMAKE_BUILD_TYPE}" BUILDTYPE)
if(BUILDTYPE MATCHES RELEASE AND NOT BUILD_TESTING)
    if("${CMAKE_VERSION}" VERSION_LESS "3.3")
        # Earlier cmake versions generate .deb packages for which the package manager says they're bad quality
        # and asks the user whether they really want to install it. Cmake 3.3 fixes this.
        message(WARNING "Distribution package generation is only supported for CMake version >= 3.3. You're using ${CMAKE_VERSION}. You will be able to build and install CryFS, but you won't be able to generate .deb packages.")
    else("${CMAKE_VERSION}" VERSION_LESS "3.3")
        # Fix debfiles permissions. Unfortunately, git doesn't store file permissions.
        # When installing the .deb package and these files have the wrong permissions, the package manager complains.
        execute_process(COMMAND /bin/bash -c "chmod 0755 ${CMAKE_CURRENT_SOURCE_DIR}/debfiles/*")

        set(CPACK_GENERATOR TGZ DEB RPM)
        set(CPACK_PACKAGE_NAME "cryfs")
        get_git_version(GITVERSION_VERSION_STRING)
        set(CPACK_PACKAGE_VERSION "${GITVERSION_VERSION_STRING}")
        set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Encrypt your files and store them in the cloud.")
        set(CPACK_PACKAGE_DESCRIPTION "CryFS encrypts your files, so you can safely store them anywhere. It works well together with cloud services like Dropbox, iCloud, OneDrive and others.")
        set(CPACK_PACKAGE_CONTACT "Sebastian Messmer <messmer@cryfs.org>")
        set(CPACK_PACKAGE_VENDOR "Sebastian Messmer")
        set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/../LICENSE")
        set(CPACK_PACKAGE_INSTALL_DIRECTORY "CMake ${CMake_VERSION_MAJOR}.${CMake_VERSION_MINOR}")
        if(WIN32 AND NOT UNIX)
            # There is a bug in NSI that does not handle full unix paths properly. Make
            # sure there is at least one set of four (4) backlasshes.
            #set(CPACK_PACKAGE_ICON "${CMake_SOURCE_DIR}/Utilities/Release\\\\InstallIcon.bmp")
            #set(CPACK_NSIS_INSTALLED_ICON_NAME "bin\\\\cryfs.exe")
            #set(CPACK_NSIS_DISPLAY_NAME "${CPACK_PACKAGE_INSTALL_DIRECTORY} CryFS")
            #set(CPACK_NSIS_HELP_LINK "http:\\\\\\\\www.cryfs.org")
            #set(CPACK_NSIS_URL_INFO_ABOUT "http:\\\\\\\\www.cryfs.org")
            #set(CPACK_NSIS_CONTACT "messmer@cryfs.org")
            #set(CPACK_NSIS_MODIFY_PATH ON)
        else(WIN32 AND NOT UNIX)
            set(CPACK_STRIP_FILES ON)
            set(CPACK_SOURCE_STRIP_FILES ON)
        endif(WIN32 AND NOT UNIX)
        set(CPACK_PACKAGE_EXECUTABLES "cryfs" "CryFS")
        set(CPACK_DEBIAN_PACKAGE_SECTION "utils")
        set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
        # Needs gnupg2 for postinst script
        set(CPACK_DEBIAN_PACKAGE_DEPENDS "fuse, gnupg2")

        set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://www.cryfs.org")
        set(CPACK_RPM_PACKAGE_LICENSE "LGPLv3")
        set(CPACK_DEBIAN_PACKAGE_CONTROL_EXTRA "${CMAKE_CURRENT_SOURCE_DIR}/debfiles/postinst;${CMAKE_CURRENT_SOURCE_DIR}/debfiles/postrm")

        include(CPack)
    endif("${CMAKE_VERSION}" VERSION_LESS "3.3")
endif(BUILDTYPE MATCHES RELEASE AND NOT BUILD_TESTING)

=== cpp-utils/CMakeLists.txt ===
project (cpp-utils)

set(SOURCES
        crypto/symmetric/ciphers.cpp
        crypto/kdf/Scrypt.cpp
        crypto/kdf/SCryptParameters.cpp
        crypto/kdf/PasswordBasedKDF.cpp
        crypto/RandomPadding.cpp
        process/daemonize.cpp
        process/subprocess.cpp
        tempfile/TempFile.cpp
        tempfile/TempDir.cpp
        network/HttpClient.cpp
        network/CurlHttpClient.cpp
        network/FakeHttpClient.cpp
        io/Console.cpp
        io/DontEchoStdinToStdoutRAII.cpp
        io/IOStreamConsole.cpp
        io/NoninteractiveConsole.cpp
        io/pipestream.cpp
        thread/LoopThread.cpp
        thread/ThreadSystem.cpp
        random/Random.cpp
        random/RandomGeneratorThread.cpp
        random/OSRandomGenerator.cpp
        random/PseudoRandomPool.cpp
        random/RandomDataBuffer.cpp
        random/RandomGenerator.cpp
        lock/LockPool.cpp
        data/Serializer.cpp
        data/Deserializer.cpp
        data/DataFixture.cpp
        data/DataUtils.cpp
        data/Data.cpp
        assert/backtrace.cpp
        assert/AssertFailed.cpp
        system/get_total_memory.cpp
)

add_library(${PROJECT_NAME} STATIC ${SOURCES})

target_link_libraries(${PROJECT_NAME} PUBLIC pthread curl)

# TODO From Crypto++ 5.7 on, it should support cmake with find_package() instead of find_library().
find_library_with_path(CryptoPP cryptopp CRYPTOPP_LIB_PATH)
target_link_libraries(${PROJECT_NAME} PUBLIC ${CryptoPP} scrypt spdlog)

target_add_boost(${PROJECT_NAME} filesystem system thread)
target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})

=== cryfs-cli/CMakeLists.txt ===
project (cryfs-cli)

set(SOURCES
        Cli.cpp
        VersionChecker.cpp
        CallAfterTimeout.cpp
        Environment.cpp
        program_options/utils.cpp
        program_options/ProgramOptions.cpp
        program_options/Parser.cpp
)

add_library(${PROJECT_NAME} ${SOURCES})
target_link_libraries(${PROJECT_NAME} PUBLIC cryfs cpp-utils gitversion)
target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})

if(NOT CRYFS_UPDATE_CHECKS)
    target_compile_definitions(${PROJECT_NAME} PRIVATE -DCRYFS_NO_UPDATE_CHECKS)
endif(NOT CRYFS_UPDATE_CHECKS)

add_executable(${PROJECT_NAME}_bin main.cpp)
set_target_properties(${PROJECT_NAME}_bin PROPERTIES OUTPUT_NAME cryfs)
target_link_libraries(${PROJECT_NAME}_bin PUBLIC ${PROJECT_NAME})
target_enable_style_warnings(${PROJECT_NAME}_bin)
target_activate_cpp14(${PROJECT_NAME}_bin)

install(TARGETS ${PROJECT_NAME}_bin
        DESTINATION bin
        CONFIGURATIONS Release
)

=== cryfs/CMakeLists.txt ===
project (cryfs)

set(LIB_SOURCES
#    cryfs.cpp
        config/crypto/outer/OuterConfig.cpp
        config/crypto/outer/OuterEncryptor.cpp
        config/crypto/CryConfigEncryptorFactory.cpp
        config/crypto/inner/ConcreteInnerEncryptor.cpp
        config/crypto/inner/InnerConfig.cpp
        config/crypto/inner/InnerEncryptor.cpp
        config/crypto/CryConfigEncryptor.cpp
        config/CryConfigConsole.cpp
        config/CryConfigLoader.cpp
        config/CryConfig.cpp
        config/CryConfigFile.cpp
        config/CryCipher.cpp
        config/CryConfigCreator.cpp
        filesystem/CryOpenFile.cpp
        filesystem/fsblobstore/utils/DirEntry.cpp
        filesystem/fsblobstore/utils/DirEntryList.cpp
        filesystem/fsblobstore/FsBlobStore.cpp
        filesystem/fsblobstore/FsBlobView.cpp
        filesystem/fsblobstore/FileBlob.cpp
        filesystem/fsblobstore/FsBlob.cpp
        filesystem/fsblobstore/SymlinkBlob.cpp
        filesystem/fsblobstore/DirBlob.cpp
        filesystem/CryNode.cpp
        filesystem/parallelaccessfsblobstore/DirBlobRef.cpp
        filesystem/parallelaccessfsblobstore/ParallelAccessFsBlobStore.cpp
        filesystem/parallelaccessfsblobstore/ParallelAccessFsBlobStoreAdapter.cpp
        filesystem/parallelaccessfsblobstore/FsBlobRef.cpp
        filesystem/parallelaccessfsblobstore/FileBlobRef.cpp
        filesystem/parallelaccessfsblobstore/SymlinkBlobRef.cpp
        filesystem/CrySymlink.cpp
        filesystem/CryDir.cpp
        filesystem/cachingfsblobstore/DirBlobRef.cpp
        filesystem/cachingfsblobstore/CachingFsBlobStore.cpp
        filesystem/cachingfsblobstore/FsBlobRef.cpp
        filesystem/cachingfsblobstore/FileBlobRef.cpp
        filesystem/cachingfsblobstore/SymlinkBlobRef.cpp
        filesystem/CryFile.cpp
        filesystem/CryDevice.cpp
)

add_library(${PROJECT_NAME} STATIC ${LIB_SOURCES})
set_target_properties(${PROJECT_NAME} PROPERTIES OUTPUT_NAME cryfs)
target_link_libraries(${PROJECT_NAME} PRIVATE cpp-utils blockstore blobstore fspp gitversion) # TODO Check that dependent projects don't get this linked in
target_add_boost(${PROJECT_NAME} program_options chrono) # TODO Check that dependent projects don't get boost added (use PRIVATE here)
target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})

#install(TARGETS ${PROJECT_NAME}
#        DESTINATION lib
#        CONFIGURATIONS Release
#)

=== googletest/CMakeLists.txt ===
include(CTest)

if (BUILD_TESTING)
  # When test cases are build, disable "make install", because this would also install gtest libraries.
  macro(install)
  endmacro(install)
  add_subdirectory(gtest-1.7.0)

  project (googletest)
  add_library(${PROJECT_NAME} dummy.cpp)
  target_link_libraries(${PROJECT_NAME} gtest gmock gmock_main)
  target_include_directories(${PROJECT_NAME} SYSTEM INTERFACE ${gtest_INCLUDE_DIRS}/include SYSTEM ${gmock_INCLUDE_DIRS}/include)
endif (BUILD_TESTING)

=== spdlog/CMakeLists.txt ===
project (spdlog)

set(SOURCES
  dummy.cpp
)

add_library(${PROJECT_NAME} STATIC ${SOURCES})
target_include_directories(${PROJECT_NAME} SYSTEM PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

=== debian/changelog ===
cryfs (0.9.6-1) unstable; urgency=medium

  * New upstream version.
  * Compile with the remote update check disabled

 -- David Steele <steele@debian.org>  Mon, 17 Oct 2016 07:44:14 -0400

cryfs (0.9.5-5) unstable; urgency=medium

  * Support libcrypto++ 5.6.4.

 -- David Steele <steele@debian.org>  Sun, 09 Oct 2016 22:46:06 -0400

cryfs (0.9.5-4) unstable; urgency=low

  * Initial release. (Closes: #837127)
  * More copyright detail

 -- David Steele <steele@debian.org>  Fri, 16 Sep 2016 20:13:34 -0400

cryfs (0.9.5-3) URELEASED; urgency=low

  * Changes to support arch any.
  * Found another copyright to log.
  * Initial release. (Closes: #837127)

 -- David Steele <steele@debian.org>  Wed, 14 Sep 2016 10:29:30 -0400

cryfs (0.9.5-2) UNRELEASED; urgency=medium

  * Update copyright file.
  * Initial release. (Closes: #837127)

 -- David Steele <steele@debian.org>  Mon, 12 Sep 2016 18:48:10 -0400

cryfs (0.9.5-1) UNRELEASED; urgency=medium

  * Initial release. (Closes: #837127)

 -- David Steele <steele@debian.org>  Thu, 08 Sep 2016 14:23:42 -0400

=== debian/control ===
Source: cryfs
Maintainer: David Steele <steele@debian.org>
Section: utils
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake,
               libcurl4-openssl-dev,
               libboost-filesystem-dev,
               libboost-system-dev,
               libboost-chrono-dev,
               libboost-program-options-dev,
               libboost-thread-dev,
               libcrypto++-dev (>= 5.6.4),
               libssl-dev,
               libfuse-dev,
               python-all,
               ruby-ronn
Standards-Version: 3.9.8
Vcs-Browser: https://github.com/davesteele/cryfs
Vcs-Git: https://github.com/davesteele/cryfs.git -b debian
Homepage: https://www.cryfs.org/

Package: cryfs
Architecture: any
Depends: fuse,
         libcrypto++6,
         libcurl3,
         libfuse2,
         libgcc1,
         libstdc++6 (>= 6),
         ${misc:Depends},
         ${shlibs:Depends}
Description: encrypt your files and store them in the cloud
 CryFS encrypts your files, so you can safely store them anywhere. It works
 well together with cloud services like Dropbox, iCloud, OneDrive and others.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE = 1

PKD = $(word 1,$(abspath $(dir $(MAKEFILE_LIST))))
PKG = $(shell dpkg-parsechangelog -l$(PKD)/changelog --show-field=Source)
VER ?= $(shell (dpkg-parsechangelog -l$(PKD)/changelog | grep Version | sed 's/Version..//' | sed 's/-.\+//'))


%:
	dh $@ --parallel


override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release -DBoost_USE_STATIC_LIBs=off \
                             -DCRYFS_UPDATE_CHECKS=off

CHDATE = $(shell grep "\-\-" debian/changelog | head -1 | sed 's/.\+, //' | sed 's/...\:.\+//' )
DT = $(shell date -d "${CHDATE}" "+%Y-%m-%d")

override_dh_auto_build:
	dh_auto_build
	cp obj*/src/cryfs-cli/cryfs .
	ronn --date=${DT} debian/*.ronn

.PHONY get-orig-source:
get-orig-source:  $(info I: $(PKG)_$(VER))
	@echo "# Downloading..."
	uscan --noconf --verbose --rename --destdir=$(CURDIR) --check-dirname-level=0 --force-download --download-version $(VER) $(PK)
	rm -f $(PKG)-$(VER).tar.gz.pgp

## cryfs 0.9.7

=== debian/changelog ===
cryfs (0.9.7-2) unstable; urgency=medium

  * Fix FTBFS due to macro overload in spdlog (Closes: #875640).
    Thanks Victor Zverovich.
  * Save the upstream tar signature for archiving.

 -- David Steele <steele@debian.org>  Tue, 12 Sep 2017 20:55:01 -0400

cryfs (0.9.7-1) unstable; urgency=medium

  * New upstream version.
  * Build tests by default, and add CI testing.
  * Compiles with gcc7 (Closes: 853360).

 -- David Steele <steele@debian.org>  Fri, 19 May 2017 09:03:19 -0400

=== debian/control ===
--- 
+++ 
@@ -16,6 +16,7 @@
                python-all,
                ruby-ronn
 Standards-Version: 3.9.8
+Testsuite: autopkgtest
 Vcs-Browser: https://github.com/davesteele/cryfs
 Vcs-Git: https://github.com/davesteele/cryfs.git -b debian
 Homepage: https://www.cryfs.org/

=== debian/rules ===
--- 
+++ 
@@ -13,7 +13,7 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release -DBoost_USE_STATIC_LIBs=off \
-                             -DCRYFS_UPDATE_CHECKS=off
+                             -DCRYFS_UPDATE_CHECKS=off -DBUILD_TESTING=True
 
 CHDATE = $(shell grep "\-\-" debian/changelog | head -1 | sed 's/.\+, //' | sed 's/...\:.\+//' )
 DT = $(shell date -d "${CHDATE}" "+%Y-%m-%d")
@@ -27,4 +27,4 @@
 get-orig-source:  $(info I: $(PKG)_$(VER))
 	@echo "# Downloading..."
 	uscan --noconf --verbose --rename --destdir=$(CURDIR) --check-dirname-level=0 --force-download --download-version $(VER) $(PK)
-	rm -f $(PKG)-$(VER).tar.gz.pgp
+	mv $(PKG)-$(VER).tar.gz.pgp $(PKG)_$(VER).orig.tar.gz.asc

## cryfs 0.9.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -39,11 +39,13 @@
         set(CPACK_PACKAGE_EXECUTABLES "cryfs" "CryFS")
         set(CPACK_DEBIAN_PACKAGE_SECTION "utils")
         set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
-        # Needs gnupg2 for postinst script
-        set(CPACK_DEBIAN_PACKAGE_DEPENDS "fuse, gnupg2")
+        # Needs gnupg2, lsb-release for postinst script
+        set(CPACK_DEBIAN_PACKAGE_DEPENDS "fuse, gnupg2, lsb-release")
 
         set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://www.cryfs.org")
         set(CPACK_RPM_PACKAGE_LICENSE "LGPLv3")
+        set(CPACK_RPM_PACKAGE_DESCRIPTION ${CPACK_PACKAGE_DESCRIPTION})
+        set(CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION "/usr/bin;/usr/share/man;/usr/share/man/man1")
         set(CPACK_DEBIAN_PACKAGE_CONTROL_EXTRA "${CMAKE_CURRENT_SOURCE_DIR}/debfiles/postinst;${CMAKE_CURRENT_SOURCE_DIR}/debfiles/postrm")
 
         include(CPack)

=== blobstore/CMakeLists.txt ===
project (blobstore-test)

set(SOURCES
    implementations/onblocks/utils/MaxZeroSubtractionTest.cpp
    implementations/onblocks/utils/CeilDivisionTest.cpp
    implementations/onblocks/utils/IntPowTest.cpp
    implementations/onblocks/utils/CeilLogTest.cpp
    implementations/onblocks/testutils/BlobStoreTest.cpp
    implementations/onblocks/BlobStoreTest.cpp
    implementations/onblocks/datanodestore/DataLeafNodeTest.cpp
    implementations/onblocks/datanodestore/DataInnerNodeTest.cpp
    implementations/onblocks/datanodestore/DataNodeViewTest.cpp
    implementations/onblocks/datanodestore/DataNodeStoreTest.cpp
    implementations/onblocks/datatreestore/testutils/DataTreeTest.cpp
    implementations/onblocks/datatreestore/impl/GetLowestRightBorderNodeWithMoreThanOneChildOrNullTest.cpp
    implementations/onblocks/datatreestore/impl/GetLowestInnerRightBorderNodeWithLessThanKChildrenOrNullTest.cpp
    implementations/onblocks/datatreestore/DataTreeTest_ResizeByTraversing.cpp
    implementations/onblocks/datatreestore/DataTreeTest_NumStoredBytes.cpp
    implementations/onblocks/datatreestore/DataTreeTest_ResizeNumBytes.cpp
    implementations/onblocks/datatreestore/DataTreeStoreTest.cpp
    implementations/onblocks/datatreestore/DataTreeTest_TraverseLeaves.cpp
    implementations/onblocks/BlobSizeTest.cpp
    implementations/onblocks/BlobReadWriteTest.cpp
    implementations/onblocks/BigBlobsTest.cpp

)

add_executable(${PROJECT_NAME} ${SOURCES})
target_link_libraries(${PROJECT_NAME} googletest blobstore)
add_test(${PROJECT_NAME} ${PROJECT_NAME})

target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})

=== blockstore/CMakeLists.txt ===
project (blockstore-test)

set(SOURCES
    utils/BlockStoreUtilsTest.cpp
    interface/helpers/BlockStoreWithRandomKeysTest.cpp
    interface/BlockStoreTest.cpp
    interface/BlockTest.cpp
    implementations/testfake/TestFakeBlockStoreTest.cpp
    implementations/inmemory/InMemoryBlockStoreTest.cpp
    implementations/parallelaccess/ParallelAccessBlockStoreTest_Generic.cpp
    implementations/parallelaccess/ParallelAccessBlockStoreTest_Specific.cpp
    implementations/compressing/CompressingBlockStoreTest.cpp
    implementations/compressing/compressors/testutils/CompressorTest.cpp
    implementations/encrypted/EncryptedBlockStoreTest_Generic.cpp
    implementations/encrypted/EncryptedBlockStoreTest_Specific.cpp
    implementations/ondisk/OnDiskBlockStoreTest_Generic.cpp
    implementations/ondisk/OnDiskBlockStoreTest_Specific.cpp
    implementations/ondisk/OnDiskBlockTest/OnDiskBlockCreateTest.cpp
    implementations/ondisk/OnDiskBlockTest/OnDiskBlockFlushTest.cpp
    implementations/ondisk/OnDiskBlockTest/OnDiskBlockLoadTest.cpp
    implementations/caching/CachingBlockStoreTest_Generic.cpp
    implementations/caching/CachingBlockStoreTest_Specific.cpp
    implementations/caching/cache/QueueMapTest_Values.cpp
    implementations/caching/cache/testutils/MinimalKeyType.cpp
    implementations/caching/cache/testutils/CopyableMovableValueType.cpp
    implementations/caching/cache/testutils/MinimalValueType.cpp
    implementations/caching/cache/testutils/QueueMapTest.cpp
    implementations/caching/cache/testutils/CacheTest.cpp
    implementations/caching/cache/QueueMapTest_Size.cpp
    implementations/caching/cache/CacheTest_MoveConstructor.cpp
    implementations/caching/cache/CacheTest_PushAndPop.cpp
    implementations/caching/cache/QueueMapTest_MoveConstructor.cpp
    implementations/caching/cache/QueueMapTest_MemoryLeak.cpp
    implementations/caching/cache/CacheTest_RaceCondition.cpp
    implementations/caching/cache/PeriodicTaskTest.cpp
    implementations/caching/cache/QueueMapTest_Peek.cpp
)

add_executable(${PROJECT_NAME} ${SOURCES})
target_link_libraries(${PROJECT_NAME} googletest blockstore)
add_test(${PROJECT_NAME} ${PROJECT_NAME})

target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})

=== cpp-utils/CMakeLists.txt ===
--- 
+++ 
@@ -12,6 +12,7 @@
         tempfile/TempDir.cpp
         network/HttpClient.cpp
         network/CurlHttpClient.cpp
+        network/CurlInitializerRAII.cpp
         network/FakeHttpClient.cpp
         io/Console.cpp
         io/DontEchoStdinToStdoutRAII.cpp

=== cryfs-cli/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,5 @@
 project (cryfs-cli)
+INCLUDE(GNUInstallDirs)
 
 set(SOURCES
         Cli.cpp
@@ -26,6 +27,6 @@
 target_activate_cpp14(${PROJECT_NAME}_bin)
 
 install(TARGETS ${PROJECT_NAME}_bin
-        DESTINATION bin
+        DESTINATION ${CMAKE_INSTALL_BINDIR}
         CONFIGURATIONS Release
 )

=== cryfs/CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,7 @@
 
 set(LIB_SOURCES
 #    cryfs.cpp
+        CryfsException.cpp
         config/crypto/outer/OuterConfig.cpp
         config/crypto/outer/OuterEncryptor.cpp
         config/crypto/CryConfigEncryptorFactory.cpp

=== fspp/CMakeLists.txt ===
project (fspp-test)

set(SOURCES
    testutils/FuseTest.cpp
    testutils/FuseThread.cpp
    testutils/InMemoryFile.cpp
    impl/FuseOpenFileListTest.cpp
    impl/IdListTest.cpp
    fuse/lstat/FuseLstatReturnUidTest.cpp
    fuse/lstat/testutils/FuseLstatTest.cpp
    fuse/lstat/FuseLstatReturnCtimeTest.cpp
    fuse/lstat/FuseLstatReturnGidTest.cpp
    fuse/lstat/FuseLstatPathParameterTest.cpp
    fuse/lstat/FuseLstatReturnNlinkTest.cpp
    fuse/lstat/FuseLstatReturnModeTest.cpp
    fuse/lstat/FuseLstatReturnAtimeTest.cpp
    fuse/lstat/FuseLstatErrorTest.cpp
    fuse/lstat/FuseLstatReturnMtimeTest.cpp
    fuse/lstat/FuseLstatReturnSizeTest.cpp
    fuse/read/FuseReadFileDescriptorTest.cpp
    fuse/read/testutils/FuseReadTest.cpp
    fuse/read/FuseReadOverflowTest.cpp
    fuse/read/FuseReadErrorTest.cpp
    fuse/read/FuseReadReturnedDataTest.cpp
    fuse/flush/testutils/FuseFlushTest.cpp
    fuse/flush/FuseFlushErrorTest.cpp
    fuse/flush/FuseFlushFileDescriptorTest.cpp
    fuse/rename/testutils/FuseRenameTest.cpp
    fuse/rename/FuseRenameErrorTest.cpp
    fuse/rename/FuseRenameFilenameTest.cpp
    fuse/utimens/testutils/FuseUtimensTest.cpp
    fuse/utimens/FuseUtimensErrorTest.cpp
    fuse/utimens/FuseUtimensFilenameTest.cpp
    fuse/utimens/FuseUtimensTimeParameterTest.cpp
    fuse/unlink/testutils/FuseUnlinkTest.cpp
    fuse/unlink/FuseUnlinkErrorTest.cpp
    fuse/unlink/FuseUnlinkFilenameTest.cpp
    fuse/ftruncate/testutils/FuseFTruncateTest.cpp
    fuse/ftruncate/FuseFTruncateFileDescriptorTest.cpp
    fuse/ftruncate/FuseFTruncateSizeTest.cpp
    fuse/ftruncate/FuseFTruncateErrorTest.cpp
    fuse/fstat/testutils/FuseFstatTest.cpp
    fuse/fstat/FuseFstatParameterTest.cpp
    fuse/fstat/FuseFstatErrorTest.cpp
    fuse/truncate/FuseTruncateSizeTest.cpp
    fuse/truncate/testutils/FuseTruncateTest.cpp
    fuse/truncate/FuseTruncateErrorTest.cpp
    fuse/truncate/FuseTruncateFilenameTest.cpp
    fuse/statfs/FuseStatfsReturnFilesTest.cpp
    fuse/statfs/FuseStatfsReturnFfreeTest.cpp
    fuse/statfs/FuseStatfsReturnNamemaxTest.cpp
    fuse/statfs/testutils/FuseStatfsTest.cpp
    fuse/statfs/FuseStatfsReturnBsizeTest.cpp
    fuse/statfs/FuseStatfsErrorTest.cpp
    fuse/statfs/FuseStatfsReturnBfreeTest.cpp
    fuse/statfs/FuseStatfsPathParameterTest.cpp
    fuse/statfs/FuseStatfsReturnBlocksTest.cpp
    fuse/statfs/FuseStatfsReturnBavailTest.cpp
    fuse/closeFile/FuseCloseTest.cpp
    fuse/fsync/testutils/FuseFsyncTest.cpp
    fuse/fsync/FuseFsyncFileDescriptorTest.cpp
    fuse/fsync/FuseFsyncErrorTest.cpp
    fuse/openFile/testutils/FuseOpenTest.cpp
    fuse/openFile/FuseOpenFilenameTest.cpp
    fuse/openFile/FuseOpenFlagsTest.cpp
    fuse/openFile/FuseOpenFileDescriptorTest.cpp
    fuse/openFile/FuseOpenErrorTest.cpp
    fuse/access/FuseAccessFilenameTest.cpp
    fuse/access/testutils/FuseAccessTest.cpp
    fuse/access/FuseAccessModeTest.cpp
    fuse/access/FuseAccessErrorTest.cpp
    fuse/BasicFuseTest.cpp
    fuse/rmdir/testutils/FuseRmdirTest.cpp
    fuse/rmdir/FuseRmdirErrorTest.cpp
    fuse/rmdir/FuseRmdirDirnameTest.cpp
    fuse/fdatasync/testutils/FuseFdatasyncTest.cpp
    fuse/fdatasync/FuseFdatasyncErrorTest.cpp
    fuse/fdatasync/FuseFdatasyncFileDescriptorTest.cpp
    fuse/mkdir/testutils/FuseMkdirTest.cpp
    fuse/mkdir/FuseMkdirErrorTest.cpp
    fuse/mkdir/FuseMkdirModeTest.cpp
    fuse/mkdir/FuseMkdirDirnameTest.cpp
    fuse/write/FuseWriteErrorTest.cpp
    fuse/write/testutils/FuseWriteTest.cpp
    fuse/write/FuseWriteOverflowTest.cpp
    fuse/write/FuseWriteFileDescriptorTest.cpp
    fuse/write/FuseWriteDataTest.cpp
    fuse/readDir/testutils/FuseReadDirTest.cpp
    fuse/readDir/FuseReadDirDirnameTest.cpp
    fuse/readDir/FuseReadDirErrorTest.cpp
    fuse/readDir/FuseReadDirReturnTest.cpp
    fuse/createAndOpenFile/FuseCreateAndOpenFilenameTest.cpp
    fuse/createAndOpenFile/testutils/FuseCreateAndOpenTest.cpp
    fuse/createAndOpenFile/FuseCreateAndOpenFlagsTest.cpp
    fuse/createAndOpenFile/FuseCreateAndOpenFileDescriptorTest.cpp
    fuse/createAndOpenFile/FuseCreateAndOpenErrorTest.cpp
    fuse/FilesystemTest.cpp
    fs_interface/NodeTest.cpp
    fs_interface/FileTest.cpp
    fs_interface/DirTest.cpp
    fs_interface/DeviceTest.cpp
    fs_interface/OpenFileTest.cpp
)

add_executable(${PROJECT_NAME} ${SOURCES})
target_link_libraries(${PROJECT_NAME} googletest fspp)
add_test(${PROJECT_NAME} ${PROJECT_NAME})

target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})

=== gitversion/CMakeLists.txt ===
project (gitversion)

include(gitversion.cmake)
get_git_version(GIT_VERSION)

set(SOURCES
    gitversion.cpp
    versionstring.cpp
    parser.cpp
    VersionCompare.cpp
)

add_library(${PROJECT_NAME} STATIC ${SOURCES})
target_link_libraries(${PROJECT_NAME})
target_compile_definitions(${PROJECT_NAME} PRIVATE GIT_VERSION_STRING="${GIT_VERSION}")
target_add_boost(${PROJECT_NAME})
target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})

=== googletest/CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
   # When test cases are build, disable "make install", because this would also install gtest libraries.
   macro(install)
   endmacro(install)
-  add_subdirectory(gtest-1.7.0)
+  add_subdirectory(gtest-1.8.0)
 
   project (googletest)
   add_library(${PROJECT_NAME} dummy.cpp)

=== parallelaccessstore/CMakeLists.txt ===
project (parallelaccessstore-test)

set(SOURCES
    ParallelAccessBaseStoreTest.cpp
    DummyTest.cpp
)

add_executable(${PROJECT_NAME} ${SOURCES})
target_link_libraries(${PROJECT_NAME} googletest parallelaccessstore)
add_test(${PROJECT_NAME} ${PROJECT_NAME})

target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})

=== scrypt/CMakeLists.txt ===
include(ExternalProject)

project (scrypt C)

# This builds the original scrypt source using configure & make. We don't use their build result,
# but we use the config.h it creates somewhere on the way (see target_compile_options below).
string(TOUPPER "${CMAKE_BUILD_TYPE}" BUILDTYPE)
set(SCRYPT_CFLAGS "${CMAKE_C_FLAGS} ${CMAKE_C_FLAGS_${BUILDTYPE}}")

# Add a default location for homebrew-installed openssl on Mac OS X to include search path
if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  set(SCRYPT_CFLAGS "${SCRYPT_CFLAGS} -I/usr/local/opt/openssl/include")
endif(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")

ExternalProject_Add(scrypt_original
        SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/scrypt-1.2.0/scrypt
        CONFIGURE_COMMAND /usr/bin/env CC=${CMAKE_C_COMPILER} CFLAGS=${SCRYPT_CFLAGS} ${CMAKE_CURRENT_SOURCE_DIR}/scrypt-1.2.0/scrypt/configure --prefix=${CMAKE_BINARY_DIR}/vendor/scrypt/
        PREFIX ${CMAKE_BINARY_DIR}/vendor/scrypt/
        BUILD_COMMAND ${MAKE}
)
add_library(${PROJECT_NAME} STATIC
        ${CMAKE_CURRENT_SOURCE_DIR}/scrypt-1.2.0/scrypt/lib/crypto/crypto_scrypt.c
        ${CMAKE_CURRENT_SOURCE_DIR}/scrypt-1.2.0/scrypt/lib/crypto/crypto_scrypt_smix.c
        ${CMAKE_CURRENT_SOURCE_DIR}/scrypt-1.2.0/scrypt/libcperciva/util/warnp.c
        ${CMAKE_CURRENT_SOURCE_DIR}/scrypt-1.2.0/scrypt/libcperciva/util/insecure_memzero.c
        ${CMAKE_CURRENT_SOURCE_DIR}/scrypt-1.2.0/scrypt/libcperciva/alg/sha256.c
        ${CMAKE_CURRENT_SOURCE_DIR}/scrypt-1.2.0/scrypt/libcperciva/cpusupport/cpusupport_x86_aesni.c
        ${CMAKE_CURRENT_SOURCE_DIR}/scrypt-1.2.0/scrypt/libcperciva/cpusupport/cpusupport_x86_sse2.c
)
target_link_libraries(${PROJECT_NAME}
        ${CMAKE_CURRENT_BINARY_DIR}/src/scrypt_original-build/libscrypt_sse2.a
        ${CMAKE_CURRENT_BINARY_DIR}/src/scrypt_original-build/libcperciva_aesni.a
)
target_include_directories(${PROJECT_NAME} PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR}/scrypt-1.2.0/scrypt
        ${CMAKE_CURRENT_SOURCE_DIR}/scrypt-1.2.0/scrypt/libcperciva/cpusupport
        ${CMAKE_CURRENT_SOURCE_DIR}/scrypt-1.2.0/scrypt/libcperciva/alg
        ${CMAKE_CURRENT_SOURCE_DIR}/scrypt-1.2.0/scrypt/libcperciva/util
)
target_compile_options(${PROJECT_NAME} PRIVATE
        -DCONFIG_H_FILE=\"${CMAKE_CURRENT_BINARY_DIR}/src/scrypt_original-build/config.h\"
        -DCPUSUPPORT_CONFIG_FILE=\"${CMAKE_CURRENT_BINARY_DIR}/src/scrypt_original-build/cpusupport-config.h\"
)
add_dependencies(${PROJECT_NAME} scrypt_original)
target_include_directories(${PROJECT_NAME} SYSTEM INTERFACE ${CMAKE_CURRENT_SOURCE_DIR}/scrypt-1.2.0)

=== spdlog/CMakeLists.txt ===


=== debian/changelog ===
cryfs (0.9.9-1ubuntu1) bionic; urgency=medium

  * Drop hard-coded dependency on libcurl3.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 01 Mar 2018 09:20:37 -0800

cryfs (0.9.9-1build1) bionic; urgency=medium

  * No-change rebuild against libcurl4

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 28 Feb 2018 06:48:42 +0000

cryfs (0.9.9-1) unstable; urgency=medium

  *  New upstream version.

 -- David Steele <steele@debian.org>  Wed, 07 Feb 2018 20:54:27 -0500

cryfs (0.9.8-1) unstable; urgency=medium

  * New upstream version.
  * Use the upstream man page.

 -- David Steele <steele@debian.org>  Tue, 16 Jan 2018 20:13:37 -0500

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: cryfs
-Maintainer: David Steele <steele@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: David Steele <steele@debian.org>
 Section: utils
 Priority: optional
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 10),
                cmake,
                libcurl4-openssl-dev,
                libboost-filesystem-dev,
@@ -14,9 +15,7 @@
                libssl-dev,
                libfuse-dev,
                python-all,
-               ruby-ronn
-Standards-Version: 3.9.8
-Testsuite: autopkgtest
+Standards-Version: 4.1.2
 Vcs-Browser: https://github.com/davesteele/cryfs
 Vcs-Git: https://github.com/davesteele/cryfs.git -b debian
 Homepage: https://www.cryfs.org/
@@ -25,7 +24,6 @@
 Architecture: any
 Depends: fuse,
          libcrypto++6,
-         libcurl3,
          libfuse2,
          libgcc1,
          libstdc++6 (>= 6),

=== debian/rules ===
--- 
+++ 
@@ -21,7 +21,6 @@
 override_dh_auto_build:
 	dh_auto_build
 	cp obj*/src/cryfs-cli/cryfs .
-	ronn --date=${DT} debian/*.ronn
 
 .PHONY get-orig-source:
 get-orig-source:  $(info I: $(PKG)_$(VER))

=== debian/tests/control ===

# cryfs-cli-test and fspp-test are disabled for requiring fuse

Tests: blobstore-test, blockstore-test, parallelaccessstore-test, cryfs-test, gitversion-test
Depends: @, @builddeps@
Restrictions: build-needed

## cryfs 0.9.10

=== CMakeLists.txt ===
project (doc)
INCLUDE(GNUInstallDirs)

find_program(GZIP gzip)

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/cryfs.1.gz
  COMMAND ${GZIP} -c ${CMAKE_CURRENT_SOURCE_DIR}/man/cryfs.1 > ${CMAKE_CURRENT_BINARY_DIR}/cryfs.1.gz
)
add_custom_target(man ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/cryfs.1.gz)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cryfs.1.gz
        DESTINATION ${CMAKE_INSTALL_MANDIR}/man1
        CONFIGURATIONS Release
)

=== cpp-utils/CMakeLists.txt ===
project (cpp-utils-test)

set(SOURCES
    EitherIncludeTest.cpp
    crypto/symmetric/CipherTest.cpp
    crypto/symmetric/testutils/FakeAuthenticatedCipher.cpp
    crypto/kdf/SCryptTest.cpp
    crypto/kdf/SCryptParametersTest.cpp
    MacrosIncludeTest.cpp
    pointer/unique_ref_test.cpp
    pointer/cast_include_test.cpp
    pointer/cast_test.cpp
    pointer/unique_ref_boost_optional_gtest_workaround_include_test.cpp
    pointer/optional_ownership_ptr_include_test.cpp
    pointer/optional_ownership_ptr_test.cpp
    pointer/unique_ref_include_test.cpp
    process/daemonize_include_test.cpp
    process/subprocess_include_test.cpp
    tempfile/TempFileTest.cpp
    tempfile/TempFileIncludeTest.cpp
    tempfile/TempDirIncludeTest.cpp
    tempfile/TempDirTest.cpp
    network/CurlHttpClientTest.cpp
    network/FakeHttpClientTest.cpp
    io/ConsoleIncludeTest.cpp
    io/ConsoleTest_AskYesNo.cpp
    io/ConsoleTest_Print.cpp
    io/ConsoleTest_Ask.cpp
    random/RandomIncludeTest.cpp
    lock/LockPoolIncludeTest.cpp
    lock/ConditionBarrierIncludeTest.cpp
    lock/MutexPoolLockIncludeTest.cpp
    data/FixedSizeDataTest.cpp
    data/DataFixtureIncludeTest.cpp
    data/DataFixtureTest.cpp
    data/DataTest.cpp
    data/FixedSizeDataIncludeTest.cpp
    data/DataIncludeTest.cpp
    logging/LoggingLevelTest.cpp
    logging/LoggerTest.cpp
    logging/LoggingTest.cpp
    logging/LoggerIncludeTest.cpp
    logging/LoggingIncludeTest.cpp
    EitherTest.cpp
    assert/assert_release_test.cpp
    assert/backtrace_include_test.cpp
    assert/assert_include_test.cpp
    assert/assert_debug_test.cpp
)

add_executable(${PROJECT_NAME} ${SOURCES})
target_link_libraries(${PROJECT_NAME} googletest cpp-utils)
add_test(${PROJECT_NAME} ${PROJECT_NAME})

target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})

=== fspp/CMakeLists.txt ===
project (fspp)

set(SOURCES
  impl/FilesystemImpl.cpp
  impl/Profiler.cpp
  fuse/Fuse.cpp
)

add_library(${PROJECT_NAME} STATIC ${SOURCES})

target_compile_definitions(${PROJECT_NAME} PUBLIC _FILE_OFFSET_BITS=64)
target_link_libraries(${PROJECT_NAME} PUBLIC cpp-utils)

target_add_boost(${PROJECT_NAME} filesystem system thread chrono)
target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})

if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  set(CMAKE_FIND_FRAMEWORK LAST)
  set(FUSE_LIB_NAME "osxfuse")
else(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  set(FUSE_LIB_NAME "fuse")
endif(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")

find_library_with_path(FUSE ${FUSE_LIB_NAME} FUSE_LIB_PATH)
target_link_libraries(${PROJECT_NAME} PUBLIC ${FUSE})

=== gitversion/CMakeLists.txt ===
project (gitversion-test)

set(SOURCES
    ParserTest.cpp
    VersionCompareTest.cpp
)

add_executable(${PROJECT_NAME} ${SOURCES})
target_link_libraries(${PROJECT_NAME} googletest gitversion)
add_test(${PROJECT_NAME} ${PROJECT_NAME})

target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})

=== debian/changelog ===
cryfs (0.9.10-2) unstable; urgency=medium

  * Avoid gcc segfault by skipping mipsel test build.

 -- David Steele <steele@debian.org>  Fri, 25 Jan 2019 20:22:13 -0500

cryfs (0.9.10-1) unstable; urgency=medium

  * New upstream version.

 -- David Steele <steele@debian.org>  Tue, 22 Jan 2019 21:20:28 -0500

cryfs (0.9.9-2) unstable; urgency=high

  * Remove hard-coded shared library dependencies (Closes: #900357, #900435).

 -- David Steele <dsteele@gmail.com>  Tue, 05 Jun 2018 19:47:03 -0400

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: cryfs
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: David Steele <steele@debian.org>
+Maintainer: David Steele <steele@debian.org>
 Section: utils
 Priority: optional
 Build-Depends: debhelper (>= 10),
@@ -23,10 +22,6 @@
 Package: cryfs
 Architecture: any
 Depends: fuse,
-         libcrypto++6,
-         libfuse2,
-         libgcc1,
-         libstdc++6 (>= 6),
          ${misc:Depends},
          ${shlibs:Depends}
 Description: encrypt your files and store them in the cloud

=== debian/rules ===
#!/usr/bin/make -f

ARCH := $(shell uname -m)

%:
	dh $@


override_dh_auto_configure:
	if [ "$(ARCH)" = "mipsel" ] ; then \
	    dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release -DBoost_USE_STATIC_LIBs=off \
                             -DCRYFS_UPDATE_CHECKS=off -DBUILD_TESTING=False; \
	else \
	    dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release -DBoost_USE_STATIC_LIBs=off \
                             -DCRYFS_UPDATE_CHECKS=off -DBUILD_TESTING=True; \
	fi

CHDATE = $(shell grep "\-\-" debian/changelog | head -1 | sed 's/.\+, //' | sed 's/...\:.\+//' )
DT = $(shell date -d "${CHDATE}" "+%Y-%m-%d")

override_dh_auto_build:
	dh_auto_build
	cp obj*/src/cryfs-cli/cryfs .

=== debian/watch ===
version=3

opts=pgpsigurlmangle=s/(.*)/$1.asc/ \
https://github.com/cryfs/cryfs/releases .*/download/([\.0-9]+)/cryfs-[\.0-9]+\.tar\.gz

## cryfs 0.9.11

=== debian/changelog ===
cryfs (0.9.11-1+deepin) unstable; urgency=medium

  * upgrade version

 -- Gong Heng <gongheng@uniontech.com>  Mon, 9 May 2022 16:30:00 +0800

cryfs (0.9.10-3+deepin) unstable; urgency=medium

  * Introduce openssl library
  * introduced the SM4 secret algorithm

 -- Gong Heng <gongheng@uniontech.com>  Mon, 9 May 2022 16:30:00 +0800

=== debian/control ===
--- 
+++ 
@@ -4,6 +4,8 @@
 Priority: optional
 Build-Depends: debhelper (>= 10),
                cmake,
+               pkg-config,
+               openssl,
                libcurl4-openssl-dev,
                libboost-filesystem-dev,
                libboost-system-dev,
